/***************************************************/
/*  examples program for ET-LAB3A                  */ 
/* description : close loop control                */ 
/* compiler    : hi-tech c51                       */
/***************************************************/

/*  include section */
#include <8051.h>
#include <stdio.h>
#include <intrpt.h>


/*  define  section  */
#define  E   P1_BITS.B2
#define  RW  P1_BITS.B1
#define  RS  P1_BITS.B0

char lcdbuf[17];

/*  pototype section */
void init_lcd(void);
void gotolcd(unsigned char);
void write_ins(unsigned char);
void write_data(unsigned char);
void printlcd(void);
void delay(char);
void interrupt timer1(void);

unsigned int pv; 
unsigned int ms;


/***************************************************/
/*                  main program                   */
/***************************************************/
void main(void)
{
  unsigned char sp = 20;
  char ee;
  unsigned char mv = 0;

  set_vector(TIMER1,timer1);

  delay(10);
  init_lcd();
  
  P3 = 0xFE;

  ET1 = 1;
  TMOD = 0x15;

  while(1)
  {
    TH1  = 0xF3;
    TL1  = 0xFF;
    TH0  = 0x00;
    TL0  = 0x00;

    ms = 0;
    TR0 = 1;
    TR1 = 1;
    EA  = 1;
  
    while(ms < 500) {}
  
    EA  = 0;
    TR0 = 0;
    TR1 = 0;
    
    pv = TH0;
    pv <<= 8;
    pv |= TL0;

    ee = sp-pv;    
    ee = ee/2;
    mv += ee;
	
    if(mv > 150) {mv = 150;}
    P0 = mv;

    gotolcd(0x00); 
    sprintf(lcdbuf," speed %04d rps ",pv);
    printlcd();

   }
}


/**************************************************/
/*           timer1 interrupt service             */
/**************************************************/
void interrupt timer1(void)
{
  ms++;
  TH1  = 0xF3; 
  TL1  = 0xFF;
 return;
}


/**************************************************/
/*              print ascii to lcd                */
/**************************************************/
void printlcd(void)
{
 char i;
 char *p;
 
 p = lcdbuf;
 for(i = 0;i < 16;i++)
 {
    write_data(*p); 
    p++;
 }
 
 return;
}


/**************************************************/
/*                 initial lcd                    */
/**************************************************/
void init_lcd(void)
{
  write_ins(0x33);
  write_ins(0x32);
  write_ins(0x28);
  write_ins(0x08);
  write_ins(0x01);
  write_ins(0x02);
  write_ins(0x0f);

 return;
}


/**************************************************/
/*                 move lcd cursor                */
/**************************************************/
void gotolcd(unsigned char i)
{
  i |= 0x80;

  write_ins(i); 
 
  return;
}


/***************************************************/
/*         write instruction lcd command           */
/***************************************************/
void write_ins(unsigned char i)
{
  
  P1 = i & 0xF0;
  E = 1;    delay(2);
  E = 0;    delay(2);

  P1 = (i << 4) & 0xF0;
  E = 1;   delay(2);
  E = 0;   delay(2);

 return;
}


/******************************************************/
/*            write data command lcd                  */
/******************************************************/
void write_data(unsigned char i)
{
  
  P1 = (i & 0xF0) | 0x01;
  E = 1;    delay(2);
  E = 0;    delay(2);

  P1 = ((i << 4) & 0xF0) | 0x01;
  E = 1;    delay(2);
  E = 0;    delay(2);

 return;
}


/*****************************************************/
/*                delay program                      */
/*****************************************************/
void delay(char i)
{
  unsigned int j;

  do
  {
    for(j=0;j<500;j++) {}
	i--; 
  }while(i > 0);

return;
}
